<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css"
    integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
  <title>employee</title>
</head>

<body>
  <div>

    <div style="margin-left: 330px;">
      <h2 style="margin:5px" class="text-dark" id="title">EmployeeForm</h2>
      <p id="result"> </p>




      <div>
        <div class="form-row">
          <div class="form-group col-md-6">
            <label for="inputEmail4"></label>
            <input type="email" class="form-control" id="name" placeholder="EmpName">
          </div>
          <div class="form-group col-md-6">
            <label for="inputPassword4"> </label>
            <input type="text" class="form-control" id="Degination" placeholder="EmpD">
          </div>
        </div>
        <div class="form-group col-md-6">
          <label for="inputPassword4"> </label>
          <input type="number" class="form-control" id="EmpPhoneNo" placeholder="EmpPhoneNo">
        </div>

        <div class="form-group col-md-6">
          <label for="inputPassword4"> </label>
          <input type="number" class="form-control" id="EmpID" placeholder="EmpID">
        </div>
        <div class="form-group col-md-6">
          <label for="inputPassword4"> </label>
          <input type="date" class="form-control" id="EmpDOB" placeholder="EmpDOB">
        </div>
        <div class="form-group col-md-6">
          <label for="inputPassword4"> </label>
          <input type="date" class="form-control" id="EmpjoiningDate" placeholder="EmpjoiningDate">
        </div>


      </div>
    </div>

  </div>

  <p id="editindex"></p>

  <div class="mb-3" style="margin-left: 330px;">

    <button type="submit" id="submit" class="form-label btn btn-primary" onclick="Submitbutton()">Add</button>


  </div>

  <div class="row mb-3 px-5">
    <div class="col-3">
      <input id="myinput1" type="text" placeholder="Name." class="form-control" name="myinput1">
    </div>
    <div class="col-3">
      <input id="myinput2" type="text" placeholder="phoneno" class="form-control" phoneno="myinput2">
    </div>
    <div class="col-3">
      <input id="myinput3" type="text" placeholder="id" class="form-control" id="myinput3">
    </div>
    <div class="col-3">
      <button type="button" onclick="OnFilter()" class="btn btn-success">Search</button>
    </div>
  </div>
  <div class="table-primary">
    <table id="employee-detail" class="table table-dark table-bordered table-responsive">
      <tr class="table-light">
        <th scope="col">EmpName</th>
        <th scope="col">EmpD</th>
        <th scope="col">EmpPhoneNo</th>
        <th scope="col">EmpID</th>
        <th scope="col">EmpDOB</th>
        <th scope="col">EmpjoiningDate</th>
        <th scope="col">Action</th>
      </tr>
      <tbody id="table-body1">
      </tbody>
  </div>

  </table>
  <script>
    let empname = document.getElementById("name");
    let empdegination = document.getElementById("Degination");
    let empphoneno = document.getElementById("EmpPhoneNo");
    let empid = document.getElementById("EmpID");
    let empdob = document.getElementById("EmpDOB");
    let empdate = document.getElementById("EmpjoiningDate");

    let sname = document.getElementById("myinput1")
    let sphoneno = document.getElementById("myinput2")
    let sid = document.getElementById("myinput3")
    let employees = [];
    let orginalEmployees = [];
    let editedIndex = null;
    let editID = null;

    let localStorageData = localStorage.getItem("orginalEmployees");
    console.log(localStorageData)
    if (localStorageData) {
      orginalEmployees = JSON.parse(localStorageData);
      employees = orginalEmployees
      console.log("madhu", localStorageData)
      console.log(orginalEmployees)
      addDataToTable();


    }




    function Submitbutton() {
      const empID = empid.value;

      const indexS = orginalEmployees.findIndex(x => x.id === empID);
      if (indexS !== -1) {
        alert('Employee ID already exits');
        return;
      }

      let employee = {
        degination: empdegination.value,
        phoneno: empphoneno.value,
        id: empid.value,
        dob: empdob.value,
        date: empdate.value,
        name: empname.value,
      };

      console.log('emp', employee)
      if (editID) { //(editedIndex != null) {
        const findIndex = orginalEmployees.findIndex(x => x.id == editID);
        orginalEmployees[findIndex] = employee;
        // editedIndex = null
        editID = null;
      } else {
        orginalEmployees.push(employee);
      }


      console.log('emps', orginalEmployees)
      employees = orginalEmployees;
      localStorage.setItem("orginalEmployees", JSON.stringify(orginalEmployees));
      addDataToTable()
      reset()

    }





    let namevalue = sname.value



    function addDataToTable() {

      let htmlData = '';
      for (const [employee_id, employee] of employees.entries()) {
        // for(let i=0;i<employees.length; i++){
        htmlData += `
        <tr id ='${employee_id}'>
          
        
          <td>${employee.name}</td>
          <td>${employee.degination}</td>
          <td>${employee.phoneno}</td>
          <td>${employee.id}</td>
          <td>${employee.dob}</td>
          <td>${employee.date}</td>
          
         
          <td>
            <button type="button" class="form-label" id="edit"  onclick="Editbutton(${employee.id})">Edit</button>
    <button type="button" class="form-label"  onclick="Deletebutton(${employee_id})">Delete</button>
   

 
   
          </td>
        </tr>
        `;
      }
      console.log({ htmlData });
      document.getElementById('table-body1').innerHTML = htmlData;



    }

    function reset() {
      empname.value = '';
      empphoneno.value = '';
      empid.value = '';
      empdob.value = '';
      empdate.value = '';
      empdegination.value = '';
    }

 







 
    function Deletebutton(emp_id) {
      console.log('j', emp_id);
  

 
         const employee = orginalEmployees.findIndex(x => x.id === emp_id);
      //  const employee = orginalEmployees.indexOf("emp_id");
        console.log( 'emp',employee);  
        if (employee === -1) {
          
        }

        
        orginalEmployees.splice(employee, 1);
            console.log('originalEmployees:', orginalEmployees);

       
        
        const rowDelete = document.getElementById(emp_id);
        console.log('row',rowDelete)
        if (rowDelete) {
          rowDelete.remove();
        }
        
        // if(employee == emp_id){
        //   console.log(emp_id);
        //   console.log('originalEmployees:', originalEmployees);
        
//   localStorage.removeItem("orginalEmployees");
//  orginalEmployees.shift(employee, 1);
  localStorage.setItem("orginalEmployees", JSON.stringify(orginalEmployees));

  // ===
        }
   

     


    function Editbutton(emp_id) {
      console.log('j', emp_id);
      const employee = orginalEmployees.find(x => x.id == emp_id);
      // const employee = employees[index]
      console.log('emp', employee)
      empdegination.value = employee.degination
      empname.value = employee.name
      empid.value = employee.id
      empphoneno.value = employee.phoneno
      empdob.value = employee.dob
      empdate.value = employee.date



      // editedIndex = index;
      editID = emp_id;
    }



    // function onchange1(namevalue ,employees){

    //   // addDataToTable()

    //   for(i=0; i<employees.length;i++){

    //    let filterresult =[]
    //     namevalue = namevalue.toLowerCase()
    //     EMPname = employees[index].name.toLowerCase()

    //     if(EMPname.includes(namevalue)){
    //       const val= employees[index].name.includes(namevalue)
    //       filterresult.push(employees[index])
    //       console.log('filterresult',filterresult)
    //       return htmlData
    //       // addDataToTable()


    //       // console.log(employees[0].name)
    //       console.log("madhuri", val)
    //     }


    //     // const head=  `<h1>${ employees[i].name.includes(namevalue)}</h1>`
    //   // document.getElementById('table-body1').innerHTML= 
    //   // document.getElementById('result').innerHTML=head

    //   }
    //   console.log(sname.value)

    // }
    // const filterresult= employees.filter(onchange1)


    //     const array = [10, 21, 35, 12, 25,22,9];

    // // const greaterThanTen = array.find(element => element > 20);

    // // console.log(greaterThanTen)
    // let b=[];
    //    for(i=0; i<array.length; i++){
    //     if(array[i]>20){
    //       b.push(array[i]);
    //     }
    //     console.log('b',b)
    //    }

    function onchange1(e) {
      let searchVal = e.target.value;
      console.log('sn', searchVal);
      let searchname = [];
      for (i = 0; i < orginalEmployees.length; i++) {
        if (orginalEmployees[i].name.includes(searchVal))
          searchname.push(orginalEmployees[i])
          // let text=searchVal.toLowerCase(); 
      }

      console.log('s', searchname)
      employees = searchname;

      addDataToTable();
    }
    function onchange2(e) {
      let searchVal1 = e.target.value;
      console.log('se', searchVal1)
      let searchPhoneno = [];
      for (i = 0; i < orginalEmployees.length; i++) {
        if (orginalEmployees[i].phoneno.includes(searchVal1))
          searchPhoneno.push(orginalEmployees[i])
      }
      console.log('sp', searchPhoneno)
      employees = searchPhoneno;
      // let searchVal2 = e.target.value;
      // console.log('si',searchVal2)
      addDataToTable();
    }

    function onchange3(e) {
      let searchVal2 = e.target.value;
      console.log('si', searchVal2)
      let searchid = [];
      for (i = 0; i < orginalEmployees.length; i++) {
        if (orginalEmployees[i].id.includes(searchVal2))
          searchid.push(orginalEmployees[i])
      }
      console.log('sid', searchid)
      employees = searchid;
      // let searchVal2 = e.target.value;
      // console.log('si',searchVal2)
      addDataToTable();
    }
    // document.getElementById('myinput1').addEventListener('input', onchange1);
    // document.getElementById('myinput2').addEventListener('input', onchange2);
    // document.getElementById('myinput3').addEventListener('input', onchange3);

    function OnFilter() {
      const name = document.getElementById('myinput1').value;
      const phone = document.getElementById('myinput2').value;
      const emp_id = document.getElementById('myinput3').value;

      let filterArray = [];
      for (i = 0; i < orginalEmployees.length; i++) {
        let nameFilter = 1;
        let phoneFilter = 1;
        let empFilter = 1;

        if (name) {
          if (orginalEmployees[i].name.includes(name)) {
            nameFilter = 1;
          } else nameFilter = 0;
        }

        if (phone) {
          if (orginalEmployees[i].phoneno.includes(phone)) {
            phoneFilter = 1;
          } else phoneFilter = 0;
        }

        if (emp_id) {
          if (orginalEmployees[i].id.includes(emp_id)) {
            empFilter = 1;
          } else empFilter = 0;
        }

        if (nameFilter && phoneFilter && empFilter)
          filterArray.push(orginalEmployees[i]);
      }
      employees = filterArray;
      addDataToTable();
    };




  </script>
</body>

</html>